## ros-melodic-nerian-stereo 3.8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(nerian_stereo)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS roscpp std_msgs sensor_msgs cv_bridge
    message_generation dynamic_reconfigure)

## System dependencies are found with CMake's conventions
find_package(OpenCV REQUIRED)
find_package(Boost REQUIRED COMPONENTS system)

################################################
## Declare ROS messages, services and actions ##
################################################

# Generate messages in the 'msg' folder
add_message_files(FILES StereoCameraInfo.msg)

# Generate added messages and services with any dependencies listed here
generate_messages(DEPENDENCIES sensor_msgs)

# Generate config server C++ headers from the cfg file
generate_dynamic_reconfigure_options(cfg/NerianStereo.cfg)
include_directories(${dynamic_reconfigure_PACKAGE_PATH}/cmake/cfgbuild.cmake)
include_directories(${CMAKE_CURRENT_LIST_DIR}/cfg/cpp)

# Generate our own run-time parameter update code (from the same cfg file)
message(STATUS "Generate parameter server / dynamic_reconfigure code ...")
execute_process(COMMAND "python" "${CMAKE_CURRENT_LIST_DIR}/cfg/generate_nerian_config_cpp.py"
                "cfg/NerianStereo.cfg"
                "src/autogen_nerian_stereo_dynamic_reconfigure.cpp"
                WORKING_DIRECTORY "${CMAKE_CURRENT_LIST_DIR}/"
                RESULT_VARIABLE autogen_result
                OUTPUT_VARIABLE autogen_output
                ERROR_VARIABLE  autogen_output)
if(autogen_result)
    message(STATUS "Output of failing script:\n${autogen_output}")
    message(SEND_ERROR "Failure in code generation script")
endif()

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
#  INCLUDE_DIRS ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  LIBRARIES visiontransfer
  CATKIN_DEPENDS roscpp message_runtime sensor_msgs
#  DEPENDS system_lib
)

#######################
## libvisiontransfer ##
#######################

set(BUILD_VT 1)

if(BUILD_VT)
    # Find lib vision transfer
    execute_process(COMMAND bash -c "ls ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/nerian*.tar.xz | sed -e 's/.*software-\\(.*\\)-src.tar.xz/\\1/' | sort -V | tail -1" OUTPUT_VARIABLE VT_VERSION)
    string(REGEX REPLACE " *\n$" "" VT_VERSION "${VT_VERSION}")

    if(NOT VT_VERSION)
        message(FATAL_ERROR "libvisiontransfer not found!")
    endif()
    message(STATUS "Detected libvisiontransfer version: ${VT_VERSION}")

    # Extract sources while configuring
    execute_process(COMMAND tar --keep-newer-files --warning none -xJf ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/nerian-vision-software-${VT_VERSION}-src.tar.xz -C ${CMAKE_CURRENT_BINARY_DIR})

    # Re-extract source files if updated
    add_custom_target(nerian_stereo_untar_src ALL
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/nerian-vision-software-${VT_VERSION}-src.tar.xz
        COMMAND tar --keep-newer-files --warning none -xJf ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/nerian-vision-software-${VT_VERSION}-src.tar.xz -C ${CMAKE_CURRENT_BINARY_DIR}
    )

    # Check for SSE4.1
    include(CheckCXXCompilerFlag)
    CHECK_CXX_COMPILER_FLAG("-msse -msse2 -msse3 -msse4.1" SSE4_1_SUPPORT)
    if(SSE4_1_SUPPORT)
        set(VT_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse -msse2 -msse3 -msse4.1")
    else()
        set(VT_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    endif()

    # Build sources at runtime
    add_custom_target(nerian_stereo_visiontransfer_stub ALL
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/nerian-vision-software-${VT_VERSION}-src.tar.xz
        COMMAND ${CMAKE_COMMAND} . -DCMAKE_CXX_FLAGS=${VT_CXX_FLAGS} -DDISABLE_NATIVE=1 -DDISABLE_PCL=1 -DDISABLE_OPENCV=1
        COMMAND make
        COMMAND cp lib/libvisiontransfer.so ${CATKIN_DEVEL_PREFIX}/lib/
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/nerian-vision-software-${VT_VERSION}-src/libvisiontransfer
    )

    install(FILES ${CATKIN_DEVEL_PREFIX}/lib/libvisiontransfer.so
        DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    )

    install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/nerian-vision-software-${VT_VERSION}-src/libvisiontransfer/visiontransfer
        DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
        FILES_MATCHING PATTERN "*.h"
        PATTERN "CMakeFiles" EXCLUDE
    )

    link_directories(${CMAKE_CURRENT_BINARY_DIR}/nerian-vision-software-${VT_VERSION}-src/libvisiontransfer/lib)

    set(COLORCODER_SOURCE_FILE ${CMAKE_CURRENT_BINARY_DIR}/nerian-vision-software-${VT_VERSION}-src/nvcom/helpers/colorcoder.cpp)

else()

    # Development settings: Use local libvisiontransfer
    link_directories($ENV{VISION_TRANSFER_LIB})
    include_directories($ENV{VISION_TRANSFER_INCLUDE})
    set(COLORCODER_SOURCE_FILE $ENV{VISION_TRANSFER_INCLUDE}/../libnvshared/nvshared/imageproc/colorcoder.cpp)
    include_directories($ENV{VISION_TRANSFER_INCLUDE}/../libnvshared/nvshared/imageproc)
endif()

###########
## Build ##
###########

# Activate c++11 support
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
if(COMPILER_SUPPORTS_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
elseif(COMPILER_SUPPORTS_CXX0X)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
else()	
    message(WARNING "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
endif()

## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(${CMAKE_CURRENT_BINARY_DIR}/nerian-vision-software-${VT_VERSION}-src/libvisiontransfer
    ${CMAKE_CURRENT_BINARY_DIR}/nerian-vision-software-${VT_VERSION}-src/nvcom/helpers
    ${Boost_INCLUDE_DIRS} ${OpenCV_INCLUDE_DIRS} ${catkin_INCLUDE_DIRS})

# Declare a C++ executable
add_executable(nerian_stereo_node
    src/nerian_stereo_node_base.cpp
    src/nerian_stereo_node.cpp
    src/autogen_nerian_stereo_dynamic_reconfigure.cpp
    ${COLORCODER_SOURCE_FILE}
)

# Add cmake target dependencies of the executable
# same as for the library above
add_dependencies(nerian_stereo_node ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS}
    nerian_stereo_visiontransfer_stub ${PROJECT_NAME}_gencfg)

# Specify libraries to link a library or executable target against
target_link_libraries(nerian_stereo_node ${catkin_LIBRARIES} ${Boost_LIBRARIES}
  ${OpenCV_LIBS} visiontransfer)

# Do the same things for the nodelet (library) version, too
add_library(nerian_stereo_nodelet
    src/nerian_stereo_node_base.cpp
    src/nerian_stereo_nodelet.cpp
    src/autogen_nerian_stereo_dynamic_reconfigure.cpp
    ${COLORCODER_SOURCE_FILE}
)

add_dependencies(nerian_stereo_nodelet ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS}
    nerian_stereo_visiontransfer_stub ${PROJECT_NAME}_gencfg)

target_link_libraries(nerian_stereo_nodelet ${catkin_LIBRARIES} ${Boost_LIBRARIES}
  ${OpenCV_LIBS} visiontransfer)


#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

# Mark executables and/or libraries for installation
install(TARGETS nerian_stereo_node nerian_stereo_nodelet
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

# Install scripts
install(FILES
    scripts/download_calibration.sh
    DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
    PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
                OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE
)

install(FILES data/calib.yaml
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/data
)

install(FILES
    launch/nerian_stereo.launch
    launch/nerian_stereo_nodelet.launch
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
)

=== libvisiontransfer/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4.6)

if(COMMAND cmake_policy)
    cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

MATH(EXPR BITS ${CMAKE_SIZEOF_VOID_P}*8)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

# Search for PCL for example compilation
set(DISABLE_PCL 0 CACHE BOOL "Disables OpenCL example")
if(NOT DISABLE_PCL)
    message(STATUS "looking for PCL")
    find_package(PCL 1.3 COMPONENTS common io filters)

    if(PCL_FOUND)
        include_directories(${PCL_INCLUDE_DIRS})
        link_directories(${PCL_LIBRARY_DIRS})
        add_definitions(${PCL_DEFINITIONS})
    else()
        message(WARNING "Not building PCL examples!")
    endif()
endif()

# Search for OpenCV for example compilation
set(DISABLE_OPENCV 0 CACHE BOOL "Disables OpenCV example")
if(NOT DISABLE_OPENCV)
    message(STATUS "looking for OpenCV")
    find_package(OpenCV)
    if(OpenCV_FOUND)
        include_directories(${OpenCV_INCLUDE_DIRS})
    else()
        message(WARNING "Not building OpenCV examples!")
    endif()
endif()

# Search for python3
set(DISABLE_PYTHON 0 CACHE BOOL "Disables python library")
if(NOT DISABLE_PYTHON)
    message(STATUS "looking for python3")

    if(WIN32 AND NOT MINGW)
        # Make sure we use the Windows python, not a matching one from msys!
        set(USERPROFILE $ENV{USERPROFILE})
        if(${BITS} EQUAL 32)
            file(GLOB Python3_EXECUTABLE
                "${USERPROFILE}/AppData/Local/Programs/Python/Python3?-32/python.exe"
                "${USERPROFILE}/AppData/Local/Programs/Python/Python3??-32/python.exe")
        else()
            file(GLOB Python3_EXECUTABLE
                "${USERPROFILE}/AppData/Local/Programs/Python/Python3?/python.exe"
                "${USERPROFILE}/AppData/Local/Programs/Python/Python3??/python.exe")
        endif()

        message(WARNING "Windows build - assuming Python 3 is \"${Python3_EXECUTABLE}\".")
    else()
        set(Python3_EXECUTABLE "python3")
        # This is for CMake 3.12 and up; making sure we get python3
        find_package (Python3 COMPONENTS Interpreter HINTS "/mingw64")
        if(NOT Python3_FOUND)
            # We don't give up just yet
            message(WARNING "Failed finding python3 with FindPython3. Assuming python3 is \"${Python3_EXECUTABLE}\"")
        endif()
    endif()

    # Search for cython
    message(STATUS "looking for Cython")
    execute_process(COMMAND "${Python3_EXECUTABLE}" "-c"
"\
from distutils.core import setup\n\
from distutils.extension import Extension\n\
from Cython.Build import cythonize\n\
print('OK')\
"
        OUTPUT_VARIABLE cython_output
        OUTPUT_STRIP_TRAILING_WHITESPACE)
    if("${cython_output}" STREQUAL "OK")
        message(STATUS "Cython test successful, will build python library")
        set(BUILD_CYTHON 1)
    else()
        message(WARNING "${cython_output}")
        message(WARNING "Cython not found! Not building python library!")
    endif()
endif()

if(NOT CMAKE_SUBMODULE)
    #set the default path for built libraries to the "lib" directory
    if(NOT WIN32 OR MINGW)
        set(LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/lib)
    else()
        set(LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/lib${BITS})
    endif()
endif()

add_subdirectory(visiontransfer)
add_subdirectory(examples)

if(BUILD_CYTHON)
    add_subdirectory(python)
endif()

=== gentl-producer/test/CMakeLists.txt ===
find_package(GTest)

if(GTEST_FOUND)
   include_directories(${GTEST_INCLUDE_DIRS})

    add_executable(test-all
        test-all.cpp
        test-library.cpp
        test-system.cpp
        test-interface.cpp
        test-device.cpp
        test-stream.cpp
        test-port.cpp
        test-event.cpp
    )

    target_link_libraries(test-all ${GTEST_BOTH_LIBRARIES} pthread nerian-gentl)

    add_test(NAME test-all COMMAND "${EXECUTABLE_OUTPUT_PATH}/test-all")
else()
    message(WARNING "!!! Not building tests as Google Test library was not found!!!")
endif()

=== libvisiontransfer/examples/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR})

if(NOT WIN32 OR MINGW)
    include(CheckCXXCompilerFlag)

    # Some useful flags
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -Wall")
    CHECK_CXX_COMPILER_FLAG("-march=native" NATIVE_ARCH_SUPPORT)
    if(NATIVE_ARCH_SUPPORT AND NOT DISABLE_NATIVE)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
    endif()
    
    # No c++11 requirement for the examples, as opposed to the library
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++98")

else()
    # Visual studio settings
    set(CMAKE_DEBUG_POSTFIX "-debug")
endif()


# All examples except PCL and OpenCV
add_executable(imagetransfer_example
    imagetransfer_example.cpp
)

target_link_libraries(imagetransfer_example visiontransfer${LIB_SUFFIX})

add_executable(asynctransfer_example
    asynctransfer_example.cpp
)

target_link_libraries(asynctransfer_example visiontransfer${LIB_SUFFIX})

add_executable(server_example
    server_example.cpp
)

target_link_libraries(server_example visiontransfer${LIB_SUFFIX})

add_executable(parameter_example
    parameter_example.cpp
)

target_link_libraries(parameter_example visiontransfer${LIB_SUFFIX})

add_executable(parameter_enumeration_example
    parameter_enumeration_example.cpp
)

target_link_libraries(parameter_enumeration_example visiontransfer${LIB_SUFFIX})

add_executable(data_channels_example
    data_channels_example.cpp
)

target_link_libraries(data_channels_example visiontransfer${LIB_SUFFIX})

if(UNIX OR MINGW)
    target_link_libraries(asynctransfer_example pthread)
    target_link_libraries(imagetransfer_example pthread)
    target_link_libraries(server_example pthread)
    target_link_libraries(parameter_example pthread)
    target_link_libraries(parameter_enumeration_example pthread)
    target_link_libraries(data_channels_example pthread)
endif()

if(WIN32)
    target_link_libraries(imagetransfer_example ws2_32)
    target_link_libraries(asynctransfer_example ws2_32)
    target_link_libraries(server_example ws2_32)
    target_link_libraries(parameter_example ws2_32)
    target_link_libraries(parameter_enumeration_example ws2_32)
    target_link_libraries(data_channels_example ws2_32)
endif()

# PCL example
if(PCL_FOUND)
    add_executable(pcl_example
        pcl_example.cpp
    )

    target_link_libraries(pcl_example visiontransfer${LIB_SUFFIX} ${PCL_COMMON_LIBRARIES} ${PCL_IO_LIBRARIES} ${PCL_FILTERS_LIBRARIES})

    if(UNIX OR MINGW)
        target_link_libraries(pcl_example pthread)
    endif()

    if(WIN32)
        target_link_libraries(pcl_example ws2_32)
    endif()
endif()

# OpenCV example
if(OpenCV_FOUND)
    add_executable(opencv_example
        opencv_example.cpp
    )
    # OpenCV >=4.0 needs C++11, so we will not build this specific one with C++98
    string(REPLACE "-std=c++98" "-std=c++11" COMPILE_FLAGS_CXX11 "${CMAKE_CXX_FLAGS}")
    set_target_properties(opencv_example PROPERTIES COMPILE_FLAGS "${COMPILE_FLAGS_CXX11}")
    target_link_libraries(opencv_example visiontransfer${LIB_SUFFIX} ${OpenCV_LIBS})

    if(UNIX OR MINGW)
        target_link_libraries(opencv_example pthread)
    endif()

    if(WIN32)
        target_link_libraries(opencv_example ws2_32)
    endif()
endif()

=== libvisiontransfer/python/CMakeLists.txt ===
message(STATUS "Python build uses source directory ${CMAKE_CURRENT_SOURCE_DIR}")

set(LIBVISIONTRANSFER_SRCDIR "${CMAKE_CURRENT_SOURCE_DIR}/.." CACHE PATH "Base directory of libvisiontransfer source package")
set(LIBVISIONTRANSFER_LIBDIR "${LIBRARY_OUTPUT_PATH}" CACHE PATH "Base directory of built libvisiontransfer libraries")
set(LIBVISIONTRANSFER_EGGDIR "${LIBRARY_OUTPUT_PATH}/../python3-egg" CACHE PATH "Target directory for Python .egg packaging")
set(LIBVISIONTRANSFER_WHEELDIR "${LIBRARY_OUTPUT_PATH}/../python3-wheel" CACHE PATH "Target directory for Python .whl packaging")

if (WIN32 OR MINGW)
    # Extra libs to link in cython step
    set(LIBVISIONTRANSFER_EXTRA_LIBS "ws2_32,Iphlpapi")
else()
    set(LIBVISIONTRANSFER_EXTRA_LIBS "")
endif()

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/visiontransfer_src/__init__.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/visiontransfer_src)
file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/visiontransfer_src/visiontransfer_cpp.pxd.in DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/visiontransfer_src)
file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/visiontransfer_src/visiontransfer.pyx.in DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/visiontransfer_src)

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/tools/autogen_docstrings.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/tools)
file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/tools/autogen_parameters.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/tools)
file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/tools/generate_sources.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/tools)

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/setup.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

if(WIN32 AND NOT MINGW)
    # CMAKE_BUILD_TYPE did not work here, but we only build for Release anyway
    set(LIBNAME "/Release/visiontransfer-static${LIB_SUFFIX}.lib")
else()
    # Linux and msys builds
    set(LIBNAME "/libvisiontransfer-static${LIB_SUFFIX}.a")
endif()

# Target to call all required preprocessing and build steps for cython
#  (The || cd . is a Unix-compatible way to clear Windows errorlevel if directory already exists)
add_custom_target(cython ALL
    DEPENDS visiontransfer-static${LIB_SUFFIX}
    COMMENT "Will run the Cython build target"
    COMMAND mkdir visiontransfer || cd .
    COMMAND ${CMAKE_COMMAND} -E env PYTHONPATH="${CMAKE_CURRENT_BINARY_DIR}" LIBVISIONTRANSFER_SRCDIR="${LIBVISIONTRANSFER_SRCDIR}"
        LIBVISIONTRANSFER_LIBDIR=${LIBVISIONTRANSFER_LIBDIR} ${Python3_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/tools/autogen_docstrings.py
    COMMAND ${CMAKE_COMMAND} -E env PYTHONPATH="${CMAKE_CURRENT_BINARY_DIR}" LIBVISIONTRANSFER_SRCDIR="${LIBVISIONTRANSFER_SRCDIR}"
        LIBVISIONTRANSFER_LIBDIR=${LIBVISIONTRANSFER_LIBDIR} ${Python3_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/tools/autogen_parameters.py
    COMMAND ${CMAKE_COMMAND} -E env PYTHONPATH="${CMAKE_CURRENT_BINARY_DIR}" LIBVISIONTRANSFER_SRCDIR="${LIBVISIONTRANSFER_SRCDIR}"
        LIBVISIONTRANSFER_LIBDIR=${LIBVISIONTRANSFER_LIBDIR} ${Python3_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/tools/generate_sources.py
    COMMAND ${CMAKE_COMMAND} -E env PYTHONPATH="${CMAKE_CURRENT_BINARY_DIR}" LIBVISIONTRANSFER_SRCDIR="${LIBVISIONTRANSFER_SRCDIR}"
        LIBVISIONTRANSFER_LIBDIR=${LIBVISIONTRANSFER_LIBDIR} LIBVISIONTRANSFER_LIB=${LIBNAME}
        LIBVISIONTRANSFER_EXTRA_LIBS=${LIBVISIONTRANSFER_EXTRA_LIBS}
        ${Python3_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/setup.py build_ext
    COMMAND ${CMAKE_COMMAND} -E env PYTHONPATH="${CMAKE_CURRENT_BINARY_DIR}" LIBVISIONTRANSFER_SRCDIR="${LIBVISIONTRANSFER_SRCDIR}"
        LIBVISIONTRANSFER_LIBDIR=${LIBVISIONTRANSFER_LIBDIR} LIBVISIONTRANSFER_LIB=${LIBNAME}
        LIBVISIONTRANSFER_EXTRA_LIBS=${LIBVISIONTRANSFER_EXTRA_LIBS}
        ${Python3_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/setup.py bdist_egg --dist-dir "${LIBVISIONTRANSFER_EGGDIR}"
    COMMAND ${CMAKE_COMMAND} -E env PYTHONPATH="${CMAKE_CURRENT_BINARY_DIR}" LIBVISIONTRANSFER_SRCDIR="${LIBVISIONTRANSFER_SRCDIR}"
        LIBVISIONTRANSFER_LIBDIR=${LIBVISIONTRANSFER_LIBDIR} LIBVISIONTRANSFER_LIB=${LIBNAME}
        LIBVISIONTRANSFER_EXTRA_LIBS=${LIBVISIONTRANSFER_EXTRA_LIBS}
        ${Python3_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/setup.py bdist_wheel --dist-dir "${LIBVISIONTRANSFER_WHEELDIR}"
)

install(CODE "execute_process(COMMAND ${CMAKE_COMMAND} -E env LIBVISIONTRANSFER_LIBDIR=${LIBVISIONTRANSFER_LIBDIR} \
    LIBVISIONTRANSFER_EXTRA_LIBS=${LIBVISIONTRANSFER_EXTRA_LIBS} \
    ${Python3_EXECUTABLE} setup.py install WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})" )

=== libvisiontransfer/visiontransfer/CMakeLists.txt ===
set(HEADERS
    asynctransfer.h
    imageprotocol.h
    imagetransfer.h
    common.h
    reconstruct3d.h
    reconstruct3d-pcl.h
    alignedallocator.h
    datablockprotocol.h
    imageset.h
    imageset-opencv.h
    imagepair.h
    bitconversions.h
    datachannelservicebase.h
    datachannelservice.h
    datachannel-imu-bno080.h
    protocol-sh2-imu-bno080.h
    deviceinfo.h
    deviceenumeration.h
    internalinformation.h
    parameterinfo.h
    parametertransfer.h
    parametertransferdata.h
    scenescanparameters.h
    standardparameterids.h
    networking.h
    sensorringbuffer.h
)

set(SOURCES
    asynctransfer.cpp
    imageprotocol.cpp
    imagetransfer.cpp
    reconstruct3d.cpp
    datablockprotocol.cpp
    imageset.cpp
    bitconversions.cpp
    datachannelservicebase.cpp
    datachannelservice.cpp
    datachannel-imu-bno080.cpp
    deviceenumeration.cpp
    internalinformation.cpp
    parameterinfo.cpp
    parametertransfer.cpp
    scenescanparameters.cpp
    standardparameterids.cpp
    networking.cpp
)

if(NOT WIN32 OR MINGW)
    include(CheckCXXCompilerFlag)

    # Some useful flags
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -Wall")
    CHECK_CXX_COMPILER_FLAG("-march=native" NATIVE_ARCH_SUPPORT)
    if(NATIVE_ARCH_SUPPORT AND NOT DISABLE_NATIVE)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
    endif()

    # Activate c++11 support
    CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
    CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
    if(COMPILER_SUPPORTS_CXX11)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    elseif(COMPILER_SUPPORTS_CXX0X)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
    else()
        message(WARNING "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
    endif()
else()
	set(CMAKE_DEBUG_POSTFIX "-debug")
endif()


# Build static and shared version
add_library(visiontransfer${LIB_SUFFIX} SHARED
    ${HEADERS}
    ${SOURCES}
)

add_library(visiontransfer-static${LIB_SUFFIX} STATIC
    ${HEADERS}
    ${SOURCES}
)

if(WIN32)
    target_link_libraries(visiontransfer${LIB_SUFFIX} ws2_32 Iphlpapi)
    target_link_libraries(visiontransfer-static${LIB_SUFFIX} ws2_32 Iphlpapi)
else()
    set_target_properties(visiontransfer-static${LIB_SUFFIX}
       PROPERTIES COMPILE_FLAGS "-fPIC")
endif()

install(TARGETS visiontransfer${LIB_SUFFIX} DESTINATION lib)
install(TARGETS visiontransfer-static${LIB_SUFFIX} DESTINATION lib)
install(FILES ${HEADERS} DESTINATION include/visiontransfer)

=== debian/changelog ===
ros-melodic-nerian-stereo (3.8.0-1stretch) stretch; urgency=high

  * Updated to nerian software release version 8.1.0
  * Support for Support for 1 to 3 images in result set
  * Added new device configuration variables
  * Contributors: Konstantin Schauwecker, Ramin Yaghoubzadeh Torky

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Tue, 28 Jul 2020 22:00:00 -0000

ros-melodic-nerian-stereo (3.7.0-1stretch) stretch; urgency=high

  * Added new trigger configuration parameters
  * Updated to vision software release 7.2
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Thu, 20 Feb 2020 23:00:00 -0000

ros-melodic-nerian-stereo (3.6.0-1stretch) stretch; urgency=high

  * Updated Nerian software release to version 7.1.0
  * Correct pixel format for publication of RGB camera images
  * Fixed problem with LD_LIBRARY_PATH when running from catkin workspace
  * Contributors: Konstantin Schauwecker, Ramin Yaghoubzadeh Torky

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Wed, 04 Dec 2019 23:00:00 -0000

ros-melodic-nerian-stereo (3.5.0-1stretch) stretch; urgency=high

  * Updated to libvisiontransfer 7.0.0
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Wed, 14 Aug 2019 22:00:00 -0000

ros-melodic-nerian-stereo (3.4.0-1stretch) stretch; urgency=high

  * Updated to latest Nerian software release 6.5.0
  * New nodelet version of ROS module
  * Support for dynamic_reconfigure
  * Corrected marking of point clouds as not dense

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Tue, 18 Jun 2019 22:00:00 -0000

ros-melodic-nerian-stereo (3.3.2-1stretch) stretch; urgency=high

  * Fixed installation permissions
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Thu, 14 Feb 2019 23:00:00 -0000

ros-melodic-nerian-stereo (3.3.1-1stretch) stretch; urgency=high

  * Compile fix for older Ubuntu versions

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Thu, 07 Feb 2019 23:00:00 -0000

ros-melodic-nerian-stereo (3.3.0-1stretch) stretch; urgency=high

  * Updated to Nerian vision software release 6.4.0
  * Added functionality to use timestamps from SceneScan for timestamping transmitted messages.
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Sun, 03 Feb 2019 23:00:00 -0000

ros-melodic-nerian-stereo (3.2.1-1stretch) stretch; urgency=high

  * Updated Nerian vision software to version 6.2.1
  * Added curl dependency to package.xml
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Tue, 04 Dec 2018 23:00:00 -0000

ros-melodic-nerian-stereo (3.2.0-1stretch) stretch; urgency=high

  * Added support for colored point clouds
  * Automated detection of libvisiontransfer version
  * Updated nerian vision software to 6.2.0
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Mon, 26 Nov 2018 23:00:00 -0000

ros-melodic-nerian-stereo (3.1.1-1stretch) stretch; urgency=high

  * Fixed CMake build problem
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Mon, 12 Nov 2018 23:00:00 -0000

ros-melodic-nerian-stereo (3.1.0-1stretch) stretch; urgency=high

  * Removed arch=native flag from compiler options
  * Updated nerian vision software to 6.1.1
  * Added support for combined RGB color channel in pointcloud
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Fri, 09 Nov 2018 23:00:00 -0000

ros-melodic-nerian-stereo (3.0.2-1stretch) stretch; urgency=high

  * Fixed build errors

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Mon, 06 Aug 2018 22:00:00 -0000

ros-melodic-nerian-stereo (3.0.1-1stretch) stretch; urgency=high

  * Installing missing scripts for binary release
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Sun, 05 Aug 2018 22:00:00 -0000

ros-melodic-nerian-stereo (3.0.0-1stretch) stretch; urgency=high

  * Updated to Nerian software release 6.0.0
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Thu, 07 Jun 2018 22:00:00 -0000

ros-melodic-nerian-stereo (2.2.0-1stretch) stretch; urgency=high

  * Added support for RGB point cloud output
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Sat, 12 May 2018 22:00:00 -0000

ros-melodic-nerian-stereo (2.1.0-1stretch) stretch; urgency=high

  * New color coding scheme: rainbow
  * Automatic selection of color legend range
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Fri, 08 Dec 2017 23:00:00 -0000

ros-melodic-nerian-stereo (2.0.3-1stretch) stretch; urgency=high

  * Build fix for Ubuntu Zesty
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Thu, 19 Oct 2017 22:00:00 -0000

ros-melodic-nerian-stereo (2.0.2-1stretch) stretch; urgency=high

  * Updated to libvisiontransfer 5.0.1, which fixes synchronization bug
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Tue, 17 Oct 2017 22:00:00 -0000

ros-melodic-nerian-stereo (2.0.1-1stretch) stretch; urgency=high

  * Fixed support for 12-bit images
  * Fixed build problems

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Sun, 01 Oct 2017 22:00:00 -0000

ros-melodic-nerian-stereo (2.0.0-1stretch) stretch; urgency=high

  * Renamed node to nerian_stereo
  * Updated to libvisiontransfer 5.0.0 to support new SceneScan sensor
  * Contributors: Konstantin Schauwecker



=== debian/control ===
Source: ros-melodic-nerian-stereo
Section: misc
Priority: extra
Maintainer: Konstantin Schauwecker <konstantin.schauwecker@nerian.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, ros-melodic-catkin, ros-melodic-cv-bridge, ros-melodic-dynamic-reconfigure, ros-melodic-message-generation, ros-melodic-nodelet, ros-melodic-roscpp, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-stereo-msgs
Homepage: http://wiki.ros.org/nerian_stereo
Standards-Version: 3.9.2

Package: ros-melodic-nerian-stereo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, curl, libboost-all-dev, libcurl4-openssl-dev, ros-melodic-cv-bridge, ros-melodic-dynamic-reconfigure, ros-melodic-message-runtime, ros-melodic-nodelet, ros-melodic-roscpp, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-stereo-msgs
Description: Driver node for SceneScan and SP1 stereo vision sensors by Nerian Vision GmbH

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-nerian-stereo//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
